// -*- C++ -*-
// ACL:license
// ----------------------------------------------------------------------
// This software and ancillary information (herein called "SOFTWARE")
// called POOMA (Parallel Object-Oriented Methods and Applications) is
// made available under the terms described here.  The SOFTWARE has been
// approved for release with associated LA-CC Number LA-CC-98-65.
// 
// Unless otherwise indicated, this SOFTWARE has been authored by an
// employee or employees of the University of California, operator of the
// Los Alamos National Laboratory under Contract No. W-7405-ENG-36 with
// the U.S. Department of Energy.  The U.S. Government has rights to use,
// reproduce, and distribute this SOFTWARE. The public may copy, distribute,
// prepare derivative works and publicly display this SOFTWARE without 
// charge, provided that this Notice and any statement of authorship are 
// reproduced on all copies.  Neither the Government nor the University 
// makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this SOFTWARE.
// 
// If SOFTWARE is modified to produce derivative works, such modified
// SOFTWARE should be clearly marked, so as not to confuse it with the
// version available from LANL.
// 
// For more information about POOMA, send e-mail to pooma@acl.lanl.gov,
// or visit the POOMA web page at http://www.acl.lanl.gov/pooma/.
// ----------------------------------------------------------------------
// ACL:license
//-----------------------------------------------------------------------------
// SMARTS Runtime System: No Thread Iterate Scheduler
//
// This program was prepared by the Regents of the University of California
// at Los Alamos National Laboratory (the University) under Contract No. 
// W-7405-ENG-36 with the U.S. Department of Energy (DOE). The University has 
// certain rights in the program pursuant to the contract and the program 
// should not be copied or distributed outside your organization. All rights
// in the program are reserved by the DOE and the University. Neither the U.S.
// Government nor the University makes any warranty, express or implied, or
// assumes any liability or responsibility for the use of this software
//
#ifndef ITERATE_SCHEDULER_H
#define ITERATE_SCHEDULER_H

//----------------------------------------------------------------------
// Functions:
// template<class T> class IterateScheduler
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// The templated classes.
// This is sort of like an abstract base class, since it doesn't 
// implement anything and you can't build one of these directly.
// 
//----------------------------------------------------------------------

namespace Smarts {
template<class T>
class IterateScheduler
{
public:
  IterateScheduler() {};
  int generation() const {return generation_m;}
private:
  int generation_m;
};

template<class T>
class Iterate
{
public:
  Iterate() {};
private:


};
template<class T>
class DataObject
{
public:
  DataObject() {};
private:
};
} // close namespace Smarts
#endif// ITERATE_SCHEDULER_H
